var product = "Shirts";
var productType = "";
// let productDetails = {};

$(document).ready(function () {
  $("body").append(
    `<div class="q3d_popup" id="q3d_popup" style="display: none;"></div>`
  );

  let pluginObj = "";
  // set the product type
  //let productType = "shirt";
  var pluginload = false;
  //   loadPluginObj();
  function loadPluginObj(callback, url, g_number) {
    pluginObj = new TdsApp({
      ServiceUrl: "https://ttpv.dam3d.in",
      OrganisationId: ,
	//  for OrganisationId  conatct to info@textronic.net
      // +91 93216 91729 / +91 - 9867604882 / 8451942077 
      // Textronics Designs (I) Pvt. Ltd.,
      defaultThreeDImage: undefined, //'1296856912',
      texture: undefined, //'https://s3.ap-south-1.amazonaws.com/aws.tds/tds_textronics/4232835417/z/NTMPLaz.jpg',
      twidth: undefined, //"26.04",
      theight: undefined, //"25.65",
      productName: productType,
      appendContainerDiv: "q3d_popup",
      appendContainerDivWidth: "", //plugin container width
      appendContainerDivHeight: "", //plugin container Height
      displayUI: true,
      loadPlugin: function (obj) {
        pluginObj = obj;
        console.log("Plugin Loaded");
        pluginload = true;
        callback(url, g_number);
        if (
          screen.availWidth < 1024 ||
          window.matchMedia("(orientation: portrait)").matches
        ) {
          resizeObserver.observe(divElement);
        }
        //setTimeout(() => {
        // loadFabric();
        // $("#q3d_popup").css("display", "none");
        // }, 5000);
      },
    });
  }

  function loadFabric(element1, g_number) {
    $("#q3d_popup").css("display", "block");
    $("#q3d_popup").css("visibility", "visible");
    let Url = element1;
    let width = "2.4";
    let height = "2.8";
    pluginObj.setImageUrl(Url, width, height); // set ImageUrl and its width and height
    let groupInfo = pluginObj.groupList(); // call getting active threeDimage id against group Data
    pluginObj.LoadDrapeFabric(g_number); //pass the group Number Do you want to selected on drape fabric
    q3d_plugin_size();
  }

  //get q3d image
  function get_q3d_image() {
    // DrapeImage = "https:" + $(".product__media img").first().attr("src");
    DrapeImage = window.productDetails.q3dImage;
    if (DrapeImage === "") {
      alert(
        "Please ensure at least one product image has alt text in the format (q3d_drape_image)."
      );
      return;
    }
    console.log(DrapeImage);
    return DrapeImage;
  }

  function q3d_plugin_size(callback) {
    if (
      screen.availWidth < 1024 ||
      window.matchMedia("(orientation: portrait)").matches
    ) {
      q3d_div_width = Math.round(window.innerWidth);
      q3d_div_height = Math.round(window.innerHeight);
    } else {
      q3d_div_width = screen.availWidth * 0.25;
      q3d_div_height = screen.availHeight * 0.7;
    }
    $("#q3d_popup").css("width", q3d_div_width + "px");
    $("#q3d_popup").css("height", q3d_div_height + "px");
    // document.querySelector("#q3d_popup").style.top = `calc(100vh - ${q3d_div_height}px)`;
    if (callback) {
      callback();
    }
  }

  function q_modelheight() {
    let q3d_popup = document.querySelector(".q3d_popup");
    let branding = document.querySelector(".textronic_brand");
    let _menu_btn = document.querySelector(".q3d_menu_btn");
    let model = document.querySelector(".q3d_model");
    let m_element =
      q3d_popup.offsetHeight - (branding.offsetHeight + _menu_btn.offsetHeight);
    model.style.height = `${m_element}px`;
  }

  window.addEventListener("resize", (event) => {
    if (
      screen.availWidth < 1024 ||
      window.matchMedia("(orientation: portrait)").matches
    ) {
      q3d_plugin_size();
    }
  });

  const divElement = document.querySelector("#q3d_popup");
  const resizeObserver = new ResizeObserver((entries) => {
    entries.forEach((entry) => {
      console.log("Div size changed:", entry.contentRect);
      q3d_plugin_size(q_modelheight);
    });
  });

  $("#q3d_btn").on("click", function (event) {
    q3d_plugin_size();
    let DrapeImage = get_q3d_image();
    productType = window.productDetails.product_type;
    // console.log('DrapeImage',DrapeImage);
    if (!pluginload) {
      $(".q3d_popup").css("display", "block");
      if (productType === "suit") {
        loadPluginObj(loadFabric, DrapeImage, 1);
      }
      loadPluginObj(loadFabric, DrapeImage, 2);
      return;
    }
    let group_no = $("#groupInfo .group.active").attr("groupno");
    let g_no = Number(group_no) + 1;
    loadFabric(DrapeImage, g_no);
  });

  // get product libery name

  function q3d_getProductMetaData(product_item_id) {
    const myHeaders = new Headers();
    myHeaders.append(
      "X-Shopify-Access-Token",
      "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"
    );

    const requestOptions = {
      method: "GET",
      headers: myHeaders,
      redirect: "follow",
    };

    fetch(
      `https://shopify.textronic.in?PRODUCT_METAFIELDS=${product_item_id}&TOKEN=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`
    )
      .then((response) => response.text())
      .then((result) => {
        var meta = JSON.parse(result);
        meta.metafields.forEach(function (m, i) {
          if (m.key == "image_type") {
            window.productDetails.image_type = m.value;
          }
          if (m.key == "product") {
            window.productDetails.product = m.value;
          }
          if (m.key == "ptname") {
            window.productDetails.ptname = m.value;
          }
          if (m.key == "product_type") {
            window.productDetails.product_type = m.value;
          }
        });
      })
      .catch((error) => console.error(error));
  }

  if (q3d_templete === "q3d_prduct_page") {
    let product_item_id = window.productDetails.id;
    q3d_getProductMetaData(product_item_id);
  }

  // collection with all products
  function q3d_getCollectionProductImages() {
    return new Promise((resolve, reject) => {
      //fetch(`${window.location.origin}/admin/api/2024-10/collections/{ collection.id }/products.json`, requestOptions)
      fetch(
        `https://shopify.textronic.in?COLLECTION_PRODUCTS=${window.productDetails.id}&TOKEN=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`
      )
        .then((response) => response.json())
        .then((results) => {
          let images = results.products.map((product) => {
            // Filter images from the product that have alt = 'q3d_drape_image'
            let q3dImage = product.images
              .filter((image) => image.alt === "q3d_drape_image")
              .map((image) => image.src);

            return {
              id: product.id,
              title: product.title,
              image: product.image.src,
              q3d_image: q3dImage[0], // Storing filtered tryon images for each product
            };
          });
          window.productDetails.products = images;
          resolve(images);
        })
        .catch((error) => console.error(error));
    });
  }
  if (q3d_templete == "q3d_collection_page") {
    q3d_getCollectionProductImages();
      
  window.addEventListener("load", (event) => {
    setTimeout(() => {
        const buttons = document.querySelectorAll(".q3d_collection_btn");
        if (buttons.length > 0) {
            buttons[0].click();
        } else {
            console.error("No element with class 'q3d_collection_btn' found.");
        }
    }, 1000);
});

  }

  async function getmeta_product_data(product_item_id) {
    try {
      const myHeaders = new Headers();
      myHeaders.append(
        "X-Shopify-Access-Token",
        "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"
      );

      const requestOptions = {
        method: "GET",
        headers: myHeaders,
        redirect: "follow",
      };

      const response = await fetch(
        `https://shopify.textronic.in?PRODUCT_METAFIELDS=${product_item_id}&TOKEN=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`
      );
      if (!response.ok) {
        throw new Error("Network response was not ok");
      }
      const data = await response.json();
      data.metafields.forEach(function (m, i) {
        if (m.key == "image_type") {
          window.productDetails.image_type = m.value;
        }
        if (m.key == "product") {
          window.productDetails.product = m.value;
        }
        if (m.key == "ptname") {
          window.productDetails.ptname = m.value;
        }
        if (m.key == "product_type") {
          window.productDetails.product_type = m.value;
        }
      });

      console.log(data);
      return data;
    } catch (error) {
      console.error(
        "There has been a problem with your fetch operation:",
        error
      );
    }
  }

  $(".q3d_collection_btn").on("click", async function (event) {
    q3d_plugin_size();
    let DrapeImage = "";
    const pid = $(this).attr("pid");
    await getmeta_product_data(pid);
    const obj = window.productDetails.products;
    for (const key in obj) {
      if (obj[key].id === Number(pid)) {
        // console.log(obj[key].q3d_image);
        DrapeImage = obj[key].q3d_image;
        break;
      }
      // console.log(key, obj[key].id);
    }
    // q3d_getProductMetaData(pid);

    // load plugin for collection page
    // let DrapeImage = get_q3d_image();
    productType = window.productDetails.product_type;
    // console.log('DrapeImage',DrapeImage);
    if (!pluginload) {
      $(".q3d_popup").css("display", "block");
      if (productType === "suit") {
        loadPluginObj(loadFabric, DrapeImage, 1);
      }
      loadPluginObj(loadFabric, DrapeImage, 2);
      return;
    }
    let group_no = $("#groupInfo .group.active").attr("groupno");
    let g_no = Number(group_no) + 1;
    loadFabric(DrapeImage, g_no);
  });
});
